;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w	        
	         rozm#w  a#w DD#W
	         czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w blokOpisUwagi#w p#w listaPX#w
 		  i#w p#w pp#w przekrSpec#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w mat#w p#w pp#w pp1#w ppp#w ppp1#w)
	  
		   (setq     blok#w (strcat "RACAV")
		         nazwadoz#w (strcat "RACAV"))

		(setq pp#w (cadr (assoc "WentyleSpiroRACAV_Mater" akcesoria#w)))
			(cond ((member pp#w '("0"))  (setq ppp#w "-" ppp1#w ""))
		      	      ((member pp#w '("1"))  (setq ppp#w "-K-" ppp1#w ""))
		      	      ((member pp#w '("2"))  (setq ppp#w "-K-" ppp1#w "-316L"))
		        );cond
		      
		(setq pp#w (cadr (assoc "WentyleSpiroRACAV_Izol" akcesoria#w)))
			(cond ((member pp#w '("0"))  (setq pp1#w ""))
		      	      ((member pp#w '("1"))  (setq pp1#w "I-"))
		        );cond

		(setq pp#w (cadr (assoc "WentyleSpiroRACAV_Wyk" akcesoria#w)))
			(cond ((member pp#w '("0"))  (setq p#w "-L"))
		      	      ((member pp#w '("1"))  (setq p#w "-H"))
		        );cond


		   (setq     blok#w (strcat blok#w     ppp#w pp1#w (car rekord#w) p#w )
		         nazwadoz#w (strcat nazwadoz#w ppp#w pp1#w (car rekord#w) p#w ppp1#w ))

		   (setq   blok#w     (substr blok#w 1 28))

		   ;;(WykonDoNazwy#w)                    ;<<<<<< dodane

	             ;blok   nazwa       tytul   uwagi         producent
		(list blok#w nazwadoz#w "Regulator staego przep.CAV" ""  "SPIRO Alnor")
		);defun



(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleSpiro" "Regulator staego przep.CAV " "WentyleSpiroRACAV"  "RACAV" "SPIRO Alnor" "   "   "  " 
            "Okno_plus_ws" czyedycja#w "" nil "0"

           "WentyleSpiro3(RACAV)" "WentyleSpiro3(RACAV_11)" "WentyleSpiro3(RACAV_12)" nil nil  
                                 nil                     nil                    nil nil  
            (list (list "Materia:" "WentyleSpiroRACAV_Mater")
		  (list "Wykonanie:" "WentyleSpiroRACAV_Wyk")
		  (list "Izolacja:" "WentyleSpiroRACAV_Izol"));listaPlikowDanychWyposazenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)





(if zwrot#w  
(progn 

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            d1#w  (atof (nth 0 rekord#w))

   	    l#w   (atof (nth 1 rekord#w))
            l#w   (- l#w 72.0) ; odcicie wsuwek na kocach 2x 36mm

  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 16 zwrot#w))

   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))


   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))
   (setq sciezkaB#w (strcat scd#w (caar zwrot#w) "\\" "WentyleSpiroRACAV" ))
				  ;(nth 11 zwrot#w) "_" (nth 0 rekord#w) )) 

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

(setq wlotwylotx#w "")

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w d1#w l#w centr#w nazwa#w wlotwylotx#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w d1#w l#w centr#w nazwa#w wlotwylotx#w)))
);cond


;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))


;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w przekrSpec#w)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w przekrSpec#w)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleSpiro")


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun






;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w d1#w l#w centr#w nazwa#w wlotwylotx#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w l#w centr#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                 ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)         "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list l#w 0)       "")
));list/setq

ppzwrot#w
);defun




;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w d1#w l#w centr#w nazwa#w wlotwylotx#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje12#w samepunkty#w d1#w l#w centr#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                 ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)         "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list l#w 0)       "")
));list/setq

ppzwrot#w
);defun







;procedura rysunkowa
(defun rysuje11#w (samepunkty#w  d1 l centr nazwa1 
                    / pr wskaztu layer szerkol pA pB p0 p2 pX pY pZ styld bok gora bokp gorap rad bb ll x)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_LAYER" "_t" layer_zarys "_s" layer_zarys "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)

    (setq pX (trans '(0 0) 1 0)
           szerkol  (* 0.07 d1)
           x        (/ d1 2)
    );setq 

    (if (member (cadr (assoc "WentyleSpiroRACAV_Izol" akcesoria#w)) '("1"))
	(progn  
    	(setq x  (+ x 55.0))
    	(command "_PLINE" (list szerkol (- (/ (+ d1 110.0) 2))) (list szerkol (/ (+ d1 110.0) 2))
			  (list (- l szerkol) (/ (+ d1 110.0) 2)) (list (- l szerkol) (- (/ (+ d1 110.0) 2))) "_c")(ssadd (entlast) wskazB)
	));progn/if

    (command "_LINE" '(0 0) (list l 0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)(ssadd (entlast) wskazB)
                                               
    (command "_PLINE" (list 0 (- (/ d1 2))) (list 0 (/ d1 2)) "_a" 
    (list szerkol (/ d1 2)) "_l" (list szerkol (- (/ d1 2))) "_a" "_cl")
                                                (ssadd (entlast) wskazB)
    (command "_PLINE" (list l (- (/ d1 2))) (list l (/ d1 2)) "_a" 
    (list (- l szerkol) (/ d1 2)) "_l" (list (- l szerkol) (- (/ d1 2))) "_a" "_cl")
                                                            (ssadd (entlast) wskazB)

    (command "_LINE" (list szerkol (- (/ d1 2))) (list (- l szerkol) (- (/ d1 2))) "")
                     (ssadd (entlast) wskazB)
    (command "_LINE" (list szerkol (/ d1 2)) (list (- l szerkol) (/ d1 2)) "")
                     (ssadd (entlast) wskazB)

    (command "_PLINE" (list 0 (+ x 0.0)) (list 0 (+ x 40.0))
                      (list 212.0 (+ x 40.0)) (list 212.0 (+ x 0.0)) "_c")(ssadd (entlast) wskazB)

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ l 2) l) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0))(ssadd (entlast) wskazB)
(command "_POINT" (list l 0))(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "")

));progn/if not samepunkty#w

pX
);defun 








;procedura rysunkowa
(defun rysuje12#w (samepunkty#w  d1 l centr nazwa1 
                    / pr wskaztu layer szerkol pA pB p0 p2 pX pY pZ styld  rad bb ll )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_LAYER" "_t" layer_zarys "_s" layer_zarys "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)

    (setq pX (trans '(0 0) 1 0)
           szerkol  (* 0.07 d1)
    );setq 

    (if (member (cadr (assoc "WentyleSpiroRACAV_Izol" akcesoria#w)) '("1"))
	(progn  
    	(command "_PLINE" (list szerkol (- (/ (+ d1 110.0) 2))) (list szerkol (/ (+ d1 110.0) 2))
			  (list (- l szerkol) (/ (+ d1 110.0) 2)) (list (- l szerkol) (- (/ (+ d1 110.0) 2))) "_c")(ssadd (entlast) wskazB)
	));progn/if

    (command "_LINE" '(0 0) (list l 0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)(ssadd (entlast) wskazB)
                                               
    (command "_PLINE" (list 0 (- (/ d1 2))) (list 0 (/ d1 2)) "_a" 
    (list szerkol (/ d1 2)) "_l" (list szerkol (- (/ d1 2))) "_a" "_cl")
                                                (ssadd (entlast) wskazB)
    (command "_PLINE" (list l (- (/ d1 2))) (list l (/ d1 2)) "_a" 
    (list (- l szerkol) (/ d1 2)) "_l" (list (- l szerkol) (- (/ d1 2))) "_a" "_cl")
                                                            (ssadd (entlast) wskazB)

    (command "_LINE" (list szerkol (- (/ d1 2))) (list (- l szerkol) (- (/ d1 2))) "")
                     (ssadd (entlast) wskazB)
    (command "_LINE" (list szerkol (/ d1 2)) (list (- l szerkol) (/ d1 2)) "")
                     (ssadd (entlast) wskazB)

    (command "_PLINE" (list 0 -76.0) (list 0 76.0)
                      (list 212.0 76.0) (list 212.0 -76.0) "_c")(ssadd (entlast) wskazB)

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ l 2) l) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0))(ssadd (entlast) wskazB)
(command "_POINT" (list l 0))(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "")

));progn/if not samepunkty#w

pX
);defun 





