;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( / zwrot#w ktora#w rekord#w d1#w l#w czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w ) 

(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleSpiro" "Kratka do kanaw prostoktnych " "WentyleSpiroRHS"  "RHS" " "   "   "  
            "Okno_plus_ws" "0"
            "WentyleSpiro3(rhs)" "WentyleSpiro3(rhs_11)" "WentyleSpiro3(rhs_12)" "WentyleSpiro3(rhs_13)"  nil
                                 "WentyleSpiro3(rhs_21)" "WentyleSpiro3(rhs_22)"  nil                     nil
             (list (list "Kierunek/Akcesoria" "WentyleSpiroRHS_akcesoria") ;listaPlikowDanychWyposaenia
                   (list "Lamelki/Przepustnic." "WentyleSpiroRHS_LamelPrzep")
                   (list "Monta/Kolor" "WentyleSpiroRHS_MontKolor"))
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)


(if zwrot#w  
(progn 

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            d1#w (atof (car rekord#w))
             l#w (atof (cadr rekord#w))
  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w) )

   (if (= czyuszczelka#w "1")
   (setq     blok#w (strcat "BL" (car rekord#w) "90")
         nazwadoz#w (strcat "BL " (car rekord#w) " 90"))
   ;else
   (setq      blok#w (strcat "B" (car rekord#w) "90")
          nazwadoz#w (strcat "B " (car rekord#w) " 90") ))

   (setq blok#w (strcat blok#w "_" ktora#w))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "13")(setq ppzwrot#w (rys13#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "14")(setq ppzwrot#w (rys14#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "21")(setq ppzwrot#w (rys21#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "22")(setq ppzwrot#w (rys22#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "23")(setq ppzwrot#w (rys23#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "24")(setq ppzwrot#w (rys24#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w)))
);cond

;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

;wstawia blok
(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w nil)

;ustawia zmienne globalne
(globset00#w zwrot#w)

	;export do pliku danych wsplnych nakadki
	(dotxt#w "Wentyle")

	;export do pliku danych tego systemu zczek
	(dotxt00#w "WentyleSpiro")


;rysuje odnonik
(cond ((= strzal#w "1") (odno_strzalka#w))
      ( T               (odno_linia#w))  )

));progn/if
		
(princ)
);defun







;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                 ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 l#w)      )  ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)        )  ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list (- l#w) l#w))
));list/setq

ppzwrot#w
);defun




;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w))
    (command "_UCS" "_w")(command "_UCS" "_o" pX#w)
       (setq p00#w ( trans pX#w 0 1))
       (command "_MIRRTEXT" "0")
       (command "_MIRROR"  wskazB "" p00#w (list (car p00#w) (+ (cadr p00#w) 100)) "_Y")
    (command "_UCS" "_p")(command "_UCS" "_p")
    ));progn/if

;wysya  punkty styku rwnie jeli bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	             ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 l#w)  )  ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)    )  ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list l#w l#w))
));list/setq

ppzwrot#w
);defun




;procedura porednia rysunkowa
(defun rys13#w (samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje13#w samepunkty#w d1#w l#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                 ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 l#w)      )  ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)        )  ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
));list/setq

ppzwrot#w
);defun






;procedura rysunkowa
(defun rysuje11#w (samepunkty#w d1 l centr czyuszczelka nazwa1 
                    / pr wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq 
          rm  l
          pX (trans (list rm 0) 1 0)
     szerkol (* 0.07 d1)
          pA (trans (list (- rm (/ d1 2)) szerkol ) 1 0)
          pB (trans (list (+ rm (/ d1 2)) szerkol ) 1 0)
    );setq 
    (command "_UCS" "_o" (list rm 0))
    (command "_PLINE" (list (- (/ d1 2)) 0) (list (/ d1 2) 0) "_a" 
    (list (/ d1 2) szerkol ) "_l" (list (- (/ d1 2)) szerkol ) "_a" "_cl")
									  (ssadd (entlast) wskazB)
    (command "_UCS" "_p")

    (command "_UCS" "_z" "90")(command "_UCS" "_o" (list rm 0))
    (setq p0 (trans '(0 0) 1 0)
          p1 (trans (list (- (/ d1 2)) (- szerkol)) 1 0)
          p2 (trans (list (/ d1 2) (- szerkol)) 1 0)  
           c (trans
             (inters (trans pA 0 1)(trans pB 0 1)(trans p1 0 1)(trans p2 0 1) nil) 
             1 0)
    );setq 
    (command "_PLINE" (list (- (/ d1 2)) 0) (list (/ d1 2) 0) "_a" 
    (list (/ d1 2) (- szerkol)) "_l" (list (- (/ d1 2)) (- szerkol)) "_a" "_cl")
									  (ssadd (entlast) wskazB)
    (command "_UCS" "_p")(command "_UCS" "_p")

    (command "_ARC" "_c" '(0 0) (list rm 0) (trans p0 0 1))
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
										      (ssadd (entlast) wskazB)

    (command "_ARC" "_c" (trans c 0 1) (trans pA 0 1) (trans p1 0 1)) (ssadd (entlast) wskazB)
    (command "_ARC" "_c" (trans c 0 1) (trans pB 0 1) (trans p2 0 1)) (ssadd (entlast) wskazB)

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ l 2) 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0)      )(ssadd (entlast) wskazB)
(command "_POINT" (list (- l) l)  )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

pX
);defun 






;procedura rysunkowa
(defun rysuje13#w (samepunkty#w d1 l centr czyuszczelka nazwa1 
                    / pr wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (setvar "CLAYER" "0")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq 
          p0 (trans '(0 0) 1 0)
     szerkol (* 0.07 d1))
    (command "_LINE" (list 0 0)(list 0 (+ (/ d1 2) l 5)) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
										   (ssadd (entlast) wskazB)
    (command "_LINE" (list (- (+ (/ d1 2) 5)) l) (list (+ (/ d1 2) 5) l) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
										   (ssadd (entlast) wskazB)
    (command "_LINE"  (list (- (/ d1 2)) szerkol) (list (- (/ d1 2)) l) "")
                                           (ssadd (entlast) wskazB)
    (command "_LINE"  (list (/ d1 2) szerkol) (list (/ d1 2) l) "")
                                           (ssadd (entlast) wskazB)
    (command "_CIRCLE" (list 0 l) (/ d1 2)) (ssadd (entlast) wskazB)

    (command "_UCS" "_z" "90")
    (command "_PLINE" (list 0 (- (/ d1 2))) (list 0 (/ d1 2)) "_a" 
    (list szerkol (/ d1 2)) "_l" (list szerkol (- (/ d1 2))) "_a" "_cl")
                                                (ssadd (entlast) wskazB)
    (command "_UCS" "_p")

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ l 2) 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (setvar "TEXTSTYLE" styld)
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" p0)
;POINTY - wzgldem p0
(command "_POINT" (list 0 l)      )(ssadd (entlast) wskazB)
(command "_POINT" (list 0 0)  )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(setvar "CLAYER" layer) 

));progn/if not samepunkty#w

p0
);defun 