;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT (jednokierunkowy) W KTRYM dPa ZALENE od innego parametru ni kierunek

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w 
		    dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  ("d1mm" "150") ("d3mm" "400") ("Lmm" "140") ("Hmm" "87") ("kgTCPL" "0.5") 
;  kierunki#w (("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P3" "d3mm" "100.00" (151.929 73.3729 0.0)) 
;              ("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P2" "d1mm" "100.00" (158.929 64.6729 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;rekonstrukcja wszystkieKierPa#w poniewa na wybr wykresu ma wpyw inna wielko 
;ni kierunki przepywu
(setq wszystkieKierPa#w '())
(foreach i#w listaDoPa#w (setq wszystkieKierPa#w 
                         (append wszystkieKierPa#w (list (cadar (cadr i#w))))))

;zaadowanie danych pod odpowiednie zmienne
(if  (not dane#w)
     (progn (load (strcat sciezkaPlik#w plik#w "_danePa.lsp"))
            (setq dane#w (obliczPa1#w)) ))

;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())

(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
              kiery#w     (caddr i#w)
	      rozmiar#w   (cadr i#w) 
              parametr#w  (cadar rozmiar#w)
 	      kierunki#w  (cadddr i#w)
	      akcesoria#w (cadr (cddddr i#w)) )

	(setq zwrotObi#w '())
	(setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		          (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                         akcesoria#w dane#w )
                             ))))
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w parametr#w akcesoria#w dane#w /
		   nastawa#w p#w d#w f#w text#w wyd#w v#w zwrot#w kierTu#w )

;i#w ("P2>P1")
;rozmiar#w (("d1mm" "100") ("d3mm" "100") ("Lmm" "151") ("Hmm" "65") ("kgTCPL" "0.5"))
;kierunki#w (("P3" "d3mm" "100.00" (120.517 23.9185 0.0) "P1" "d1mm" "200.00" (112.967 
;            30.4185 0.0)) ("P2" "d1mm" "100.00" (128.067 30.4185 0.0) "P1" "d1mm" "200.00" 
;            (112.967 30.4185 0.0)))
;dane#w (("1" "2.2" "1.1") ("1" "2.3" "1.2")...)
;parametr#w "80" 
;akcesoria#w (("WentyleSpiroRGS_akcesoria" "1") ("WentyleSpiroRGS_lamelki" "1") 
;             ("WentyleSpiroRGS_przepustnica" "0"))

(setq nastawa#w (cadar akcesoria#w))
(cond
((= nastawa#w "0")(setq nastawa#w "5"))
((= nastawa#w "1")(setq nastawa#w "10"))
((= nastawa#w "2")(setq nastawa#w "15"))
((= nastawa#w "3")(setq nastawa#w "20"))
((= nastawa#w "4")(setq nastawa#w "25"))
((= nastawa#w "5")(setq nastawa#w "30"))
((= nastawa#w "6")(setq nastawa#w "35"))
((= nastawa#w "7")(setq nastawa#w "40"))
((= nastawa#w "8")(setq nastawa#w "45"))
((= nastawa#w "9")(setq nastawa#w "50"))
((= nastawa#w "10")(setq nastawa#w "55"))
((= nastawa#w "11")(setq nastawa#w "60"))
);cond

(setq kierTu#w (car kierunki#w))

               ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w)
		(setq d#w  (/ (atof (cadr (assoc d#w rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4))  ;[m2]
		(setq text#w (strcat "0;Przepustnica,Nast." nastawa#w))

(setq wyd#w  (/ (atof (nth 2 kierTu#w))  3600) ;[m3/s]
        v#w  (rtos (/ wyd#w f#w) 2 12) ) ;[m/s]


;wywoanie odczytu dPa z tablicy/wykresu
;(Kt nastawy, V[m/s], DPa[Pa])
(setq zwrot#w (LiczyPa_odczytDPa#w  nastawa#w v#w dane#w))

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 






